cmake_minimum_required(VERSION 2.8)

# You need this to find the QiBuild CMake framework
find_package(qibuild QUIET)
include(qibuild/general)

# some base variables
set(NAO_HOME $ENV{NAO_HOME})
set(SRC_DIR ${NAO_HOME}/core)
set(BHWALK_DIR ${NAO_HOME}/core/motion/bhwalk)
set(LUA_DIR ${NAO_HOME}/lib/lua/src)
set(INTERFACE_DIR ${NAO_HOME}/interfaces)
set(LIBBHWALK ${CMAKE_CURRENT_BINARY_DIR}/../core/bhwalk/libbhwalk.a)
set(LIBLUA ${CMAKE_CURRENT_BINARY_DIR}/../lua/build/liblua.a)
set(LINK_LIBS boost_thread-mt boost_system-mt libz.a dl rt)

message("C Compiler: " ${CMAKE_C_COMPILER})
message("C++ Compiler: " ${CMAKE_CXX_COMPILER})

# set the include directory, the base dir, lua, and now bhuman's walk
INCLUDE_DIRECTORIES(${SRC_DIR} ${LUA_DIR} ${BHWALK_DIR})
