#ifndef IMAGE_CONSTANTS_H
#define IMAGE_CONSTANTS_H

#define IMAGE_WIDTH 640 // Both images need to have the same width
#define IMAGE_HEIGHT 480
#define TOP_IMAGE_WIDTH IMAGE_WIDTH
#define TOP_IMAGE_HEIGHT IMAGE_HEIGHT
#define BOTTOM_IMAGE_HEIGHT IMAGE_HEIGHT
#define BOTTOM_IMAGE_WIDTH IMAGE_WIDTH
#define RAW_TOP_IMAGE_SIZE TOP_IMAGE_WIDTH * TOP_IMAGE_HEIGHT * 2
#define RAW_BOTTOM_IMAGE_SIZE BOTTOM_IMAGE_WIDTH * BOTTOM_IMAGE_HEIGHT * 2
#define IMAGE_SIZE IMAGE_HEIGHT * IMAGE_WIDTH
#define IMAGE_X IMAGE_WIDTH
#define IMAGE_Y IMAGE_HEIGHT
#define FOVx DEG_T_RAD * 60.97 // from new specs
#define FOVy DEG_T_RAD * 47.64 // from new specs

#define RAW_IMAGE_SIZE IMAGE_SIZE*2

#define DEFAULT_HORIZONTAL_STEP_SCALE 2
#define DEFAULT_VERTICAL_STEP_SCALE 1
#define FOCUS_RANGE 8 // +/- pixels around each focus point for high res scans

// to modify our size checks automatically based on image resolution
const int IMAGE_FACTOR = (float)IMAGE_X/160.0;
#endif
