-- params at robocup (bottom camera), set using Gene
-- i just reduced exposure on both top and bottom camera from the lab params

cfgCamRoboCup = {}

cfgCamRoboCup.kCameraAutoWhiteBalance = 0
cfgCamRoboCup.kCameraExposureAuto = 0 
cfgCamRoboCup.kCameraBacklightCompensation = 1
cfgCamRoboCup.kCameraBrightness = 220
cfgCamRoboCup.kCameraContrast = 53 -- your choice (20-53)
cfgCamRoboCup.kCameraSaturation = 128 -- your choice (0-255)
cfgCamRoboCup.kCameraHue = 0
cfgCamRoboCup.kCameraExposure = 0 -- leave at 0 otherwise frame rate gets hit
cfgCamRoboCup.kCameraGain = 32 -- about 200 is good
cfgCamRoboCup.kCameraSharpness = 0

-- params at TTU lab...
cfgCamTTUBot = {}

cfgCamTTUBot.kCameraAutoWhiteBalance = 0 
cfgCamTTUBot.kCameraExposureAuto = 0 
cfgCamTTUBot.kCameraBacklightCompensation = 0 
cfgCamTTUBot.kCameraBrightness = 115 
cfgCamTTUBot.kCameraContrast = 63
cfgCamTTUBot.kCameraSaturation = 120 
cfgCamTTUBot.kCameraHue = 0 
cfgCamTTUBot.kCameraExposure = 101  
cfgCamTTUBot.kCameraGain = 24 
cfgCamTTUBot.kCameraSharpness = 0 

cfgCamTTUTop = {}

cfgCamTTUTop.kCameraAutoWhiteBalance = 0 
cfgCamTTUTop.kCameraExposureAuto = 0
cfgCamTTUTop.kCameraBacklightCompensation = 0 
cfgCamTTUTop.kCameraBrightness = 120 --0:255
cfgCamTTUTop.kCameraContrast = 43 --0:127
cfgCamTTUTop.kCameraSaturation = 90 --0:256
cfgCamTTUTop.kCameraHue = 0 -- -180:180
cfgCamTTUTop.kCameraExposure = 101
cfgCamTTUTop.kCameraGain = 26
cfgCamTTUTop.kCameraSharpness = 0

CamOffset = {}
CamOffset.__index = CamOffset
function CamOffset.create(pix_x,pix_y,rel_ball_side,rel_ball_fwd)
  local tab = {}
  setmetatable(tab,CamOffset)
  tab.pix_offset_x = pix_x
  tab.pix_offset_y = pix_y
  tab.rel_ball_side = rel_ball_side
  tab.rel_ball_fwd = rel_ball_fwd
  return tab
end

-- camera offsets (only all now)
cfgCamOffsets = {} -- pixels
-- pix_x, pix_y, rel_ball_side, rel_ball_fwd
cfgCamOffsets[0] = CamOffset.create(0,0,0,0,-110) -- assume the fwd is off by center of torso to ball on foot ~100
cfgCamOffsets[27] = CamOffset.create(10, -10, -8, -93) -- 6/22/12 10pm by sbarrett
cfgCamOffsets[28] = CamOffset.create(-18, 25, 9.6, -112) -- 6/22/12 10pm by sbarrett
cfgCamOffsets[29] = CamOffset.create(4, 23, -5.8, -97) -- 6/21/12 by sbarrett
cfgCamOffsets[30] = CamOffset.create(1, 38, -1.7, -125) -- 6/1/12 by katie
cfgCamOffsets[33] = CamOffset.create(-2, -19, -5.0, -74) -- 6/20/12 2:50pm by katie
cfgCamOffsets[34] = CamOffset.create(9, 31, -5, -110) -- 6/18/12 5:10pm by katie
cfgCamOffsets[35] = CamOffset.create(1, -10, -1.0, -96) -- 6/20/12 2:40pm by katie
cfgCamOffsets[36] = CamOffset.create(2, 43, -1.5, -126) -- 6/18/12 5:20pm by katie
cfgCamOffsets[37] = CamOffset.create(15, 44, -8, -133) -- 6/18/12 4:20pm by katie 
--cfgCamOffsets[38] = CamOffset.create(-5, 47, 4.5, -132) -- 6/8/12 by katie 

function getCamOffsets()
  local offsets = cfgCamOffsets[robot_state.robot_id_]
  if offsets == nil then
    offsets = cfgCamOffsets[0]
  end
  --offsets.scale_side = 0.772 -- everyone uses the same for now
  offsets.scale_side = 1.0 -- everyone uses the same for now
  return offsets
end
