cfgStraightKick = core.KickParameters()

-- times in milliseconds
local liftAmount = 40 --25
local backAmount = -80
local throughAmount = 80
local liftAlignAmount = 60
local liftKickAmount = 25
local comHeight = 175 -- this should be the height of the walk
local comOffset = 10
local comOffsetX = 15
local info
local kick_time = 0

info = cfgStraightKick:getStateInfoPtr(core.KickState_STAND)
info.state_time = 200 -- decrease this if possible
info.joint_time = 200
info.com = core.vector3_float(comOffsetX,50,comHeight)
info.swing = core.vector3_float(0,100,0)
kick_time = kick_time + info.state_time

info = cfgStraightKick:getStateInfoPtr(core.KickState_SHIFT)
info.state_time = 150
info.joint_time = 150
info.com = core.vector3_float(comOffsetX,comOffset + 30,comHeight)
info.swing = core.vector3_float(0,100,0)
kick_time = kick_time + info.state_time

info = cfgStraightKick:getStateInfoPtr(core.KickState_LIFT)
info.state_time = 50
info.joint_time = 50
info.com = core.vector3_float(comOffsetX,comOffset,comHeight)
info.swing = core.vector3_float(0,100,10)
kick_time = kick_time + info.state_time

info = cfgStraightKick:getStateInfoPtr(core.KickState_ALIGN)
info.state_time = 150
info.joint_time = 150
info.com = core.vector3_float(comOffsetX,comOffset,comHeight)
info.swing = core.vector3_float(backAmount,100,liftAlignAmount)
kick_time = kick_time + info.state_time

info = cfgStraightKick:getStateInfoPtr(core.KickState_KICK1)
info.state_time = 0
info.joint_time = 50
info.com = core.vector3_float(comOffsetX,comOffset,comHeight)
info.swing = core.vector3_float(0,100,(liftKickAmount+liftAlignAmount)/2)
kick_time = kick_time + info.state_time

info = cfgStraightKick:getStateInfoPtr(core.KickState_KICK2)
info.state_time = 0
info.joint_time = 50
info.com = core.vector3_float(comOffsetX,comOffset,comHeight)
info.swing = core.vector3_float(throughAmount,100,liftKickAmount)
kick_time = kick_time + info.state_time

info = cfgStraightKick:getStateInfoPtr(core.KickState_RESETFOOT)
info.state_time = 150
info.joint_time = 150
info.com = core.vector3_float(comOffsetX,comOffset,comHeight)
info.swing = core.vector3_float(0,100,liftAmount)

info = cfgStraightKick:getStateInfoPtr(core.KickState_FOOTDOWN)
info.state_time = 50
info.joint_time = 50
info.com = core.vector3_float(comOffsetX,comOffset + 20,comHeight)
info.swing = core.vector3_float(0,100,liftAmount/2)

info = cfgStraightKick:getStateInfoPtr(core.KickState_SHIFTBACK)
info.state_time = 500 --75
info.joint_time = 75
info.com = core.vector3_float(comOffsetX,50,comHeight)
info.swing = core.vector3_float(0,100,0)

info = cfgStraightKick:getStateInfoPtr(core.KickState_FINISHSTAND)
info.state_time = 500
info.joint_time = 500
info.com = core.vector3_float(comOffsetX/2,50,comHeight)
info.swing = core.vector3_float(0,100,0)   

-- SPLINE STATE
info = cfgStraightKick:getStateInfoPtr(core.KickState_SPLINE)
info.state_time = 100
info.joint_time = info.state_time
info.com = core.vector3_float(comOffsetX,comOffset,comHeight)
info.swing = core.vector3_float(0,100,0)

cfgStraightKick.use_stance_spline = false
cfgStraightKick.kick_time_ = (450 + kick_time) / 1000.0
cfgStraightKick.offset_ = 10

cfgStraightKick.swing_length_ = 120
cfgStraightKick.swing_time_ = 200
cfgStraightKick.swing_frac_before_ball_ = 0.55

cfgStraightKick.align_height_ = 32.5
cfgStraightKick.kick_height_ = 32.5

-- ideal ball placements - i.e. what the kick was developed for
cfgStraightKick.ideal_ball_side_left_swing_ = 15
cfgStraightKick.ideal_ball_side_right_swing_ = -30
cfgStraightKick.ideal_ball_fwd_left_swing_ = 60
cfgStraightKick.ideal_ball_fwd_right_swing_ = 60

function setRobotSpecificKickParams()
  local id = robot_state.robot_id_
  if id == 92 then -- Gouda
    UTdebug.log(0,'Gouda Parameters')
    --cfgStraightKick.ideal_ball_side_right_swing_ = 20
  elseif id == 93 then -- Gene Jr
    UTdebug.log(0,'Gene Jr Parameters')
    --cfgStraightKick.ideal_ball_side_right_swing_ = 20
  elseif id == 96 then -- Gene Jr
    UTdebug.log(0,'Colby Jack Parameters')
    --cfgStraightKick.ideal_ball_side_right_swing_ = 20
  elseif id == 97 then -- Michael
    UTdebug.log(0,'Michael Parameters')
    --cfgStraightKick.ideal_ball_side_right_swing_ = 20
  elseif id == 99 then -- Queso
    UTdebug.log(0,'Queso Parameters')
    --cfgStraightKick.ideal_ball_side_right_swing_ = 20
  else
    UTdebug.log(0,'*** No Robot specific kick params')
  end
  UTdebug.log(0,'Done setting robot specific kick params')
end

-------------------------------------------------------------------

cfgSplineStraightKick = core.KickParameters()

-- times in milliseconds

local liftAmount = 25
local backAmount = -80
local throughAmount = 70
local liftAlignAmount = 60
local liftKickAmount = 20
local comWRTLeg = 0 -- need -10 for kicking with left leg, 0 for right
local comHeight = 245
local walkHeight = 255 --TODO: fill this in correctly
local info

cfgSplineStraightKick.use_akima_spline = true
cfgSplineStraightKick.use_stance_spline = true

info = cfgSplineStraightKick:getStateInfoPtr(core.KickState_STAND)
info.state_time = 1500
info.joint_time = 500
info.com = core.vector3_float(10,50,comHeight)
info.swing = core.vector3_float(0,100,0)

info = cfgSplineStraightKick:getStateInfoPtr(core.KickState_SHIFT)
info.state_time = -1000

info = cfgSplineStraightKick:getStateInfoPtr(core.KickState_LIFT)
info.state_time = -800

info = cfgSplineStraightKick:getStateInfoPtr(core.KickState_ALIGN)
info.state_time = -800

info = cfgSplineStraightKick:getStateInfoPtr(core.KickState_KICK1)
info.state_time = -90

info = cfgSplineStraightKick:getStateInfoPtr(core.KickState_KICK2)
info.state_time = -80

info = cfgSplineStraightKick:getStateInfoPtr(core.KickState_RESETFOOT)
info.state_time = -1000

info = cfgSplineStraightKick:getStateInfoPtr(core.KickState_FOOTDOWN)
info.state_time = -1000

info = cfgSplineStraightKick:getStateInfoPtr(core.KickState_SHIFTBACK)
info.state_time = -1000

info = cfgSplineStraightKick:getStateInfoPtr(core.KickState_FINISHSTAND)
info.state_time = 500
info.joint_time = 500
info.com = core.vector3_float(10,50,walkHeight)
info.swing = core.vector3_float(0,100,0)   

require 'cfgkickspline'
cfgSplineStraightKickSpline = cfgSpline

local time = 0
for i = 1,cfgSplineStraightKickSpline.swingNumPts do
  time = time + cfgSplineStraightKickSpline.swingTimes[i]
end
local time2 = 0
for i = 1,cfgSplineStraightKickSpline.stanceNumPts do
  time2 = time2 + cfgSplineStraightKickSpline.stanceTimes[i]
end
if (time2 ~= time) then
  print '****************'
  print '****************'
  print ('BAD SPLINE TIMES',time,time2)
  print '****************'
  print '****************'
end

info = cfgSplineStraightKick:getStateInfoPtr(core.KickState_SPLINE)
info.state_time = time
info.joint_time = time
info.com = core.vector3_float(10,comWRTLeg,comHeight)
info.swing = core.vector3_float(0,0,0)

kick_speech_text = { 
  "Large Gap",
  "Small Gap",
  "Long Straight",
  "Long Left",
  "Long Right",
  "Mid Straight",
  "Mid Left",
  "Mid Right",
  "Pass 4",
  "Pass 3",
  "Pass 2",
  "Short Straight",
  "Short Left",
  "Short Right",
  "Dribble",
  "Left Side",
  "Right Side",
  "Fast"
}
