require 'math'

-- less outlier reset
-- smaller outlier reset
-- less pos noise / more ori noise

cfgUKFHandTuned2012 = {}

-- R values for measurements of different types
cfgUKFHandTuned2012.R_goal_theta = 0.0001
cfgUKFHandTuned2012.R_goal_range_offset = 3500 
cfgUKFHandTuned2012.R_goal_range_relative = 0.1 
cfgUKFHandTuned2012.ignore_goal_dist = 700  -- in cm, since ukf is

cfgUKFHandTuned2012.R_circle_theta = 0.003
cfgUKFHandTuned2012.R_circle_range_offset = 1.0E-5
cfgUKFHandTuned2012.R_circle_range_relative = 0.03
cfgUKFHandTuned2012.ignore_circle_dist = 350

cfgUKFHandTuned2012.R_line_theta = 0.6
cfgUKFHandTuned2012.R_line_range_offset = 200
cfgUKFHandTuned2012.R_line_range_relative = 0.4
cfgUKFHandTuned2012.ignore_line_dist = 350

cfgUKFHandTuned2012.R_int_theta = 0.6
cfgUKFHandTuned2012.R_int_range_offset = 2300
cfgUKFHandTuned2012.R_int_range_relative = 0.4
cfgUKFHandTuned2012.ignore_int_dist = 350

cfgUKFHandTuned2012.R_cross_theta = cfgUKFHandTuned2012.R_int_theta
cfgUKFHandTuned2012.R_cross_range_offset = cfgUKFHandTuned2012.R_int_range_offset
cfgUKFHandTuned2012.R_cross_range_relative = cfgUKFHandTuned2012.R_int_range_relative
cfgUKFHandTuned2012.ignore_cross_dist = 200

cfgUKFHandTuned2012.R_ball_theta = 0.2
cfgUKFHandTuned2012.R_ball_range_offset = 30
cfgUKFHandTuned2012.R_ball_range_relative = 0.02
cfgUKFHandTuned2012.ignore_ball_dist = 800

cfgUKFHandTuned2012.R_kick_vel =  100
cfgUKFHandTuned2012.R_kick_bearing = 0.5
cfgUKFHandTuned2012.kick_ball_vel_reset_noise = 250.0

cfgUKFHandTuned2012.shared_ball_sd_factor = 5

cfgUKFHandTuned2012.R_crop_factor = 5.0

-- reset thresholds
cfgUKFHandTuned2012.large_angle_sd = 1.55 --0.1 --1.55 --0.001 --1e-5 --1.55
cfgUKFHandTuned2012.object_error_thresh = 0.2
cfgUKFHandTuned2012.object_error_decay = 0.88 --0.7396740477426499
cfgUKFHandTuned2012.reset_sum_thresh = 4 --3.6 --2.1 --3.673797565122742
cfgUKFHandTuned2012.reset_num_thresh = 2 --1

-- ambig object param
cfgUKFHandTuned2012.outlier_alpha_degrade = 0.2
cfgUKFHandTuned2012.t_l_mismatch_degrade = 1.0

cfgUKFHandTuned2012.kappa = 1.0
cfgUKFHandTuned2012.ball_decay_rate = 0.97 
cfgUKFHandTuned2012.outlier_rejection_thresh = 2.0
cfgUKFHandTuned2012.kick_outlier_rejection_thresh = 25.0
cfgUKFHandTuned2012.seen_ball_outlier_rejection_thresh = 8.0
cfgUKFHandTuned2012.shared_ball_outlier_rejection_thresh = 3.0
cfgUKFHandTuned2012.keeper_outlier_rejection_thresh_diff = 2.0

-- process noise
cfgUKFHandTuned2012.robot_pos_noise = 4 
cfgUKFHandTuned2012.robot_orient_noise = 0.1
cfgUKFHandTuned2012.ball_pos_noise = 25.0 
cfgUKFHandTuned2012.ball_vel_noise = 16
cfgUKFHandTuned2012.keeper_ball_vel_noise = 25 

cfgUKFHandTuned2012.robot_bump_sd_factor = 5 --2.0
cfgUKFHandTuned2012.fallen_robot_sd_factor = 12.0
cfgUKFHandTuned2012.fallen_ball_sd_factor = 5.0
cfgUKFHandTuned2012.standing_robot_sd_factor = 2.0
cfgUKFHandTuned2012.moving_ball_sd_factor = 18.0


-- std's used when resetting things
cfgUKFHandTuned2012.init_sd_x = 25
cfgUKFHandTuned2012.init_sd_y = 20
cfgUKFHandTuned2012.init_sd_theta = 0.5
cfgUKFHandTuned2012.init_sd_vel = 100 
cfgUKFHandTuned2012.reset_ball_sd_pos = 200 

cfgUKFHandTuned2012.fallen_sd_theta = 3
cfgUKFHandTuned2012.reset_sd_pos = 65
cfgUKFHandTuned2012.reset_sd_theta = 2
cfgUKFHandTuned2012.reset_sd_ball = 5

-- num models
cfgUKFHandTuned2012.max_models_after_merge = 4

-- seeding
cfgUKFHandTuned2012.seed_model_alpha = 0.2
cfgUKFHandTuned2012.min_reseed_bearing_diff = DEG_T_RAD * 2.0

-- keeping models after getup/pen
cfgUKFHandTuned2012.ambig_min_model_alpha = 0.05
cfgUKFHandTuned2012.ambig_model_min_nframes = 3
cfgUKFHandTuned2012.ambig_model_min_ball_frames = 3

-- keeper ball spawning
cfgUKFHandTuned2012.keeper_ball_spawn_freq = 30
cfgUKFHandTuned2012.keeper_ball_spawn_likelihood = 0.05
cfgUKFHandTuned2012.keeper_ball_spawn_velocity = 32 -- cm/s

-- flipped robot threshold (must be greater than this)
cfgUKFHandTuned2012.mate_flipped_ball_thresh = 5

-- which things to use
cfgUKFHandTuned2012.USE_CIRCLE = true
cfgUKFHandTuned2012.USE_GOAL = true
cfgUKFHandTuned2012.USE_WHOLE_GOAL = false --normally false, so we just use posts
cfgUKFHandTuned2012.USE_AMBIG = true

cfgUKFHandTuned2012.SPLIT_ON_POSTS = true
cfgUKFHandTuned2012.SPLIT_ON_LINES = false
cfgUKFHandTuned2012.SPLIT_LINES_ON_HIGH_SD = false --true
cfgUKFHandTuned2012.SPLIT_ON_INTS = false

cfgUKFHandTuned2012.SPLIT_LINE_SD_POS_THRESH = 70.0
cfgUKFHandTuned2012.SPLIT_LINE_SD_THETA_THRESH = 3.2 -- to be higher than fallen sd_theta


cfgUKFHandTuned2012.USE_INTERSECTIONS = false--true
cfgUKFHandTuned2012.USE_CROSSES = false --true
cfgUKFHandTuned2012.USE_BALL_IN_SET = true
cfgUKFHandTuned2012.USE_LINES = true
cfgUKFHandTuned2012.RESEED_ON_OUTLIERS = false
cfgUKFHandTuned2012.USE_SHARED_BALL = true
cfgUKFHandTuned2012.CHECK_LINES_IN_FOV = true
cfgUKFHandTuned2012.DO_RESEED = false--true


