require 'stateMachine'
require 'task'
module(..., package.seeall);

ParaTask('skills_MoveHomeSweepScan',{'body_MoveHome','head_SweepScan'})
ParaTask('skills_ToPoseMoveHead',{'body_ToPose','head_MoveHead'})
ParaTask('skills_ToPoseSweepScan',{'body_ToPose','head_SweepScan'})
ParaTask('skills_ToPoseLookForBall',{'body_ToPose','head_LookForBall'})

function isSubTaskCompleted(stateMach,as)
  local notFirst = not(stateMach:isFirstFrameInState())
  return ((as ~= nil) and notFirst and as:finished())
end

CompTask('skills_ApproachBall',{
           init = true,
           state = stateMachine.StateMachine.create('Approach Ball state',{'ApproachBall','FinalApproach','Kick'}),
           kicking = false,
           kickFound = false,
           kickChoice = core.FwdShortStraightKick,
           kickHeading = 0,
           kickDistance = 3000,
           switch = false,
           foot = core.Kick_RIGHT,
           kickData = kicks.kickData[core.FwdShortStraightKick]
         })

function skills_ApproachBall:choose(as)
  local ball = world_objects:getObjPtr(core.WO_BALL)
  local me = world_objects:getObjPtr(robot_state.WO_SELF)
  self.kicking = false

  self.kickData = kicks.kickData[self.kickChoice]
  self.kickHeading = self.kickData.heading
  self.kickDistance = self.kickData.distance
  self.foot = self.kickData.foot

  
  if (self.init) then
    self.init = false
    self.state:transition('FinalApproach')
  end

  local finalApproach = body_AlignToBallWithTargetWalk:set{alignment=self.kickData.alignment,kickChoice=self.kickChoice,desiredFoot=self.foot}
  if (self.state:inState('FinalApproach')) then
    if (as == finalApproach) and isSubTaskCompleted(self.state,as) then
      UTdebug.log(0,"Transition from final approach to kick")
      self.state:transition('Kick')
    else
      -- approach with walk to point
      -- putting these here because otherwise they don't seem to override the default values
      return finalApproach
    end
  end

  if (self.state:inState('Kick')) then
    self.kicking = true
    -- task is over
    UTdebug.log(10, "in kick, check if done", self.kickFound, self.kickChoice)
    if isSubTaskCompleted(self.state,as) then
      self.state:transition('FinalApproach')
      self.kicking = false
      UTdebug.log(10,"Transition from kick to FinalApproach")
      return as
    else
      if (self.state:isFirstFrameInState()) then
        return kicks_ExecuteKick:set{kickChoice = self.kickChoice, desiredHeading = self.kickHeading, desiredDistance = self.kickDistance}
      else
        return as
      end
    end
  end
end

function skills_ApproachBall:finished()
  return true
end
