#ifndef LOGREADER_ZN55JIC8
#define LOGREADER_ZN55JIC8

#include <fstream>
#include <cstring>
#include <vector>
#include "Memory.h"
#include "MemoryBlock.h"
#include "Log.h"

class LogReader {
public:
  LogReader (const char *filename);
  LogReader (char *buffer, unsigned long buffer_size);
  bool readMemory(Memory &memory, bool suppress_errors = false);
  virtual ~LogReader ();
  Log* readLog(int start = 0, int finish = -1);

private:

  bool readMemoryHeader(MemoryHeader &header);
  bool readBlock(const MemoryBlockHeader &header,MemoryBlock &module);
  void readAndIgnoreBlock(const MemoryBlockHeader &header);
  void close();

  std::ifstream log_file_;
  bool using_buffer_;
  char *log_buffer_;
  const unsigned long buffer_size_;
  unsigned int buffer_ind_;
  std::string filename_;

  void read(char *s, std::streamsize n);
  bool good();
};

#endif /* end of include guard: LOGREADER_ZN55JIC8 */
