#ifndef LOGGER_3AB7OTVI
#define LOGGER_3AB7OTVI

#include <fstream>
#include "Memory.h"
#include "MemoryBlock.h"
#include <common/InterfaceInfo.h>

class Logger {
public:
  Logger (const char *filename = NULL, bool appendUniqueId = false);
  Logger (char *buffer,unsigned long *msg_size,unsigned long buffer_size);
  virtual ~Logger ();

  void writeMemoryHeader(const MemoryHeader &header);
  void writeMemory(Memory &memory);
  void writeBlock(MemoryBlock &block);
  void open(const char *filename, bool appendUniqueId = false);
  void close();
  void setType(int type);

private:
  void generateUniqueFileName(char *fileName, const char *prefix, const char *ext);

  void write(const char *s, std::streamsize n);

  std::ofstream log_file_;
  char *log_buffer_;
  const unsigned long buffer_size_;
  unsigned long *msg_size_;
  int type_;
  bool using_buffer_;
};

#endif /* end of include guard: LOGGER_3AB7OTVI */
