#ifndef ROBOTVISIONBLOCK_
#define ROBOTVISIONBLOCK_

#include "MemoryBlock.h"
#include <common/RobotInfo.h>
#include <math/Geometry.h>
#include <vision/structures/HorizonLine.h>

#define MAX_VISION_OPPS 10

struct RobotVisionBlock : public MemoryBlock {

  enum VisionBodyPoints {
    LEFT_SHOULDER,
    RIGHT_SHOULDER,
    LEFT_FOOT_TL,
    LEFT_FOOT_TR,
    LEFT_FOOT_BL,
    LEFT_FOOT_BR,
    RIGHT_FOOT_TL,
    RIGHT_FOOT_TR,
    RIGHT_FOOT_BL,
    RIGHT_FOOT_BR,
    NUM_VISION_BODY_POINTS
  };

public:
  RobotVisionBlock()  {
    header.version = 4;
    header.size = sizeof(RobotVisionBlock);
    reported_head_stop_time = 0.0;
    reported_head_moving = false;
  }

  unsigned char segImgTop[IMAGE_SIZE]; // img[IMAGE_X][IMAGE_Y][3];
  unsigned char segImgBottom[IMAGE_SIZE];
  bool doHighResBallScan;
  bool lookForCross;

  double reported_head_stop_time;
  double reported_head_moving;

  Point2D bodyPointsImage[NUM_VISION_BODY_POINTS];
  HorizonLine horizon;

};

#endif
