#ifndef TEAMPACKETSBLOCK_
#define TEAMPACKETSBLOCK_

#include <common/TeamPacket.h>
#include "MemoryBlock.h"

// to be filled in by incoming team packets
struct TeamPacketsBlock : public MemoryBlock {
public:
  TeamPacketsBlock()  {
    header.version = 10;
    header.size = sizeof(TeamPacketsBlock);

    // default values
    for (int i = 0; i < 5; i++){
      frameReceived[i] = -10000;
      ballUpdated[i] = false;
      oppUpdated[i] = false;
      tp[i].robotIP = -1;
      tp[i].robotNumber = 0;
    }
    sinceLastTeamPacketIn=100;
  }

  TeamPacket getPkt(unsigned int pkt) {
    return tp[pkt];
  }
  
  TeamPacket* getPktPtr(unsigned int pkt) {
    return &(tp[pkt]);
  }

  int getFrameReceived(unsigned int pkt) {
    return frameReceived[pkt];
  }

  int getMissedFromUs(unsigned int mate, unsigned int me){
    return tp[mate].packetsMissed[me];
  }

  // Array of 5, so we can index from robot ID's 1-4. Index 0 not used.
  TeamPacket tp[5];

  int frameReceived[5];
  bool ballUpdated[5];
  bool oppUpdated[5];

  int sinceLastTeamPacketIn;
};

#endif 
