#ifndef GETUP_MODULE_H
#define GETUP_MODULE_H

#include <string>
#include <iostream>
#include <Module.h>
#include <common/RobotInfo.h>
#include <vector>

#include <motion/SpecialMotionModule.h>
#include <memory/OdometryBlock.h>

using namespace std;

class GetupModule: public SpecialMotionModule {
 public:
  GetupModule();

  bool isGettingUp();
  void initGetup();
  void processGetup();
  bool needsStand() {return specialmotion_state_ == 4;}


 private:
  void cross();
  void loseStiffness();
  void prepareFall(float diffT);
  bool doing_back_getup_;
  bool doing_front_getup_;
  bool overHeatJoint;
  float last_diffT;
  bool enterPrepare;
  vector<float> Joints_beforePrepare;
  Getup::GetupType getUpSide;
  int numCrosses;
  float loseStiffnessTime;
  float waitPrepareFallTime;
  int numPrepare;
  int frameWait;
  int enterStatusChecker;
  
  //float WAIT_FALLFULLY;

};

#endif /* end of include guard: GETUP_MODULE */
