#include "SpecialMotionModule.h"


//#define SLOW_DEBUG

const float debugVEL=0.2;
const float FAST_FACTOR=1.0;
const bool biteCMD=false;
const bool biteCMDcurr=false;
static float VEL=1.0;
#ifdef USE_EXP_FILTER 
static float waitFinishedTime=12;//12.0;
#else 
static float waitFinishedTime=240;
#endif

static string motionID= "nNull";
//{   "mNull",  "cross",   "standUpBackNao",    "standUpFrontNao"  };
const string teamID= "test";
//{ "test" , "villa",   "devils",  "bhuman", "other" };
//static bool initialized_MotionSequence=false;



/**
 int jointMapping[NUM_JOINTS] = {
  HeadYaw,
  HeadPitch,

  LShoulderPitch,
  LShoulderRoll,
  LElbowYaw,
  LElbowRoll,

  RShoulderPitch,
  RShoulderRoll,
  RElbowYaw,
  RElbowRoll,
 
  LHipYawPitch,
  LHipRoll,
  LHipPitch,
  LKneePitch,
  LAnklePitch,
  LAnkleRoll,

  RHipYawPitch,
  RHipRoll,
  RHipPitch,
  RKneePitch,
  RAnklePitch,
  RAnkleRoll
};
*/


SpecialMotionModule::SpecialMotionModule():
  specialmotion_state_(0),
  specialmotion_state_time_(0),
  doing_specialmotion_(true),
  initialized_MotionSequence(false)
{  
   teamID="test";
   VEL=1.0;
   loadMotionFile();
   heatFactors=vector<float>(NUM_JOINTS,1.0);
}

void SpecialMotionModule::initialize(const string _motionID)
{
   motionID=_motionID;
}

void SpecialMotionModule::initialize(bool& _doing_specialmotion_, const string _motionID)
{
   doing_specialmotion_=_doing_specialmotion_;
   motionID=_motionID;
}

void SpecialMotionModule::loadMotionFile()
{
   //TODO: load all at the beginning??
}

void SpecialMotionModule::specifyMemoryDependency() {
  requiresMemoryBlock("frame_info");
  requiresMemoryBlock("walk_request");
  requiresMemoryBlock("processed_joint_angles");
  requiresMemoryBlock("processed_joint_commands");
  requiresMemoryBlock("odometry");
  requiresMemoryBlock("processed_sensors");
 // std::cout<<"specialMotion mem Dependecy"<<std::endl;
}

void SpecialMotionModule::specifyMemoryBlocks() {
  getMemoryBlock(frame_info_,"frame_info");
  getMemoryBlock(walk_request_,"walk_request");
  getMemoryBlock(joint_angles_,"processed_joint_angles");
  getMemoryBlock(processed_joint_commands_,"processed_joint_commands");
  getMemoryBlock(odometry_,"odometry");
  getMemoryBlock(sensors_,"processed_sensors");
  std::cout<<"specialMotion mem Blocks"<<std::endl;
}

void SpecialMotionModule::initSpecialMotion() { 
  specialmotion_state_ = 0; 
  doing_specialmotion_ = false;
}


void SpecialMotionModule::processSpecialMotion() {

  processed_joint_commands_->send_stiffness_ = false;

  // state 0: turn off stiffness
  if (specialmotion_state_== 0) {
    specialmotion_pose_count_ = 0;
    // stiffness should already be off from lua command
    //processed_joint_commands_->send_stiffness_ = true;
    //processed_joint_commands_->stiffness_time_ = 10;
    //for (int i = 0; i < NUM_JOINTS; i++)
    //  processed_joint_commands_->stiffness_[i] = 0.0;
    specialmotion_state_=3;
   // std::cout<<"motion_state_ changed 0 to 1 -- "<<std::endl;
    std::cout<<frame_info_->seconds_since_start<<std::endl;
    specialmotion_state_time_ = frame_info_->seconds_since_start;
  }
  // state 3: start doing motion
  else if (specialmotion_state_ == 3) {
     
       if(!initialized_MotionSequence)
       {
          std::cout<<"NEED UPDATE NEW1 "<<teamID<<" "<<motionID;
          initialize_MotionSequence();
  	      std::cout<<"finishInitialized"<<std::endl;
          initialized_MotionSequence=true;
       }
    
    executeMotionSequence();

    double diff = frame_info_->seconds_since_start - specialmotion_state_time_;
    if (diff > waitFinishedTime){
        std::cout << "Special Motion complete" << std::endl;// << std::flush;
        specialmotion_state_ = 4;
    }
    
    /////////TODO:STILL NEED IT IN REAL ROBOT
    /** 
    // not yet started getup, we now think we're ok (not on front/back)
    else if (walk_request_->fallen_counter_ == 0){
      // we're done!
      std::cout<<"Right position"<<std::endl;
      specialmotion_state_ = 6;
    }
    */
 
   // start a new standup   
     else
    {
       /** might need to check?  as in state 3*/
      //   processed_joint_commands_->send_front_standup_ = true;
   		doing_specialmotion_ = true; 
        std::cout<<"start a new SpecialMotion"<<std::endl;
        executeMotionSequence();
        
     }  
  }

  // state 4: wait for finish doing special motion
  else if (specialmotion_state_ == 4){
    specialmotion_state_ = 5;
    specialmotion_state_time_ = frame_info_->seconds_since_start;
  }

  // state 5: wait for it to be stable
  else if (specialmotion_state_ == 5){
    double diff = frame_info_->seconds_since_start - specialmotion_state_time_;
    if (diff > 0.5)
      specialmotion_state_ = 6;
  }
  else 
  {
     std::cout<<"Wrong state number: "<< specialmotion_state_<<std::endl<<std::flush;
  }
 
}

void SpecialMotionModule::addMotionStart()
{
    SpecialMotion spmStart = SpecialMotion(null); 
    MotionSequence.push_back(spmStart);
}

void SpecialMotionModule::addMotionEnd2WalkStart()
{
    SpecialMotion spEndWalk = SpecialMotion(end); 
    MotionSequence.push_back(spEndWalk);
}

void SpecialMotionModule::initialize_MotionSequence()
{  
     initialize_MotionSequence(motionID);
}


void SpecialMotionModule::initialize_MotionSequence(string motionName)
{  
    string filePath;
     if(frame_info_->source == MEMORY_ROBOT)
    {
        ///real robot TODO: NEED COPY scirpt
        filePath="/home/nao";   
    }
    else
    {   ///simulator
         filePath=getenv("NAO_HOME") ;
    }
     filePath+= "/data/mof/"+teamID+"/";
     filePath+= motionName;
     filePath+=".mof";
     std::cout<<"enter: Initialized"<<filePath<<std::endl;
     MotionSequence.clear();
     times.clear();
     
     addMotionStart();
     SpecialMotionParser::ParseMotionFile(filePath,MotionSequence);

     #ifdef SLOW_DEBUG
     std::cout<<"MOTION LENGTH"<<MotionSequence.size()<<std::endl;
     for(int i=0;i<MotionSequence.size();i++)
     {   
        for(int j=0;j<NUM_JOINTS;j++)
            std::cout<<MotionSequence[i].jointMotions[j]<<" ";
        std::cout<<std::endl;
     }
     #else
     #endif

     #ifdef SLOW_DEBUG
     VEL=debugVEL;
     #else 
     #endif
     float mag=1000.0* VEL;
     

     for(int i=0; i< (MotionSequence.size()+1); i++)
    {
          float t=((i>0)?times[i-1]:0.0)+ (MotionSequence[i]).time/mag;
          times.push_back(t); 
    }
    waitFinishedTime=mag*times[MotionSequence.size()];
    #ifdef SLOW_DEBUG
    for(int i=0; i< times.size();i++)
        cout<<times[i]<<" ";
    #else
    #endif
    std::cout<<"end initialize the motionsequence"<<std::endl;
}




//basic function to call joint command
void SpecialMotionModule::processJointArray( float time,float angles[NUM_JOINTS]) {
  processed_joint_commands_->send_body_angles_=true; 
  processed_joint_commands_->send_head_pitch_angle_=true; 
  processed_joint_commands_->send_head_yaw_angle_=true; 
  processed_joint_commands_->head_pitch_angle_change_=false; 
  processed_joint_commands_->head_yaw_angle_change_=false; 

  processed_joint_commands_->body_angle_time_ = time; 
  processed_joint_commands_->head_pitch_angle_time_ = time; 
  processed_joint_commands_->head_yaw_angle_time_ = time; 
 

  for (int i=0; i<NUM_JOINTS; i++) {
    if(angles[i] < 3 && angles[i] > -3)
    {
        processed_joint_commands_->stiffness_[i] = 1.0; 
        processed_joint_commands_->angles_[i] = angles[i];
    }
    else
    {
      // sending commands so we should probably turn stiffness off
      //     std::cout<<"ignore"<<i<<" ";
      //processed_joint_commands_->stiffness_[i] = 0.0; 
      // have to give some valid angle for while stiffness is still on
      processed_joint_commands_->angles_[i] = joint_angles_->values_[i];
    }
  }
}

void SpecialMotionModule::processJointHardness(float time,float stiffness[NUM_JOINTS]) {
    if(time==0.0) return;
    processed_joint_commands_->send_stiffness_ = true;
    processed_joint_commands_->stiffness_time_ = time;
    for (int i = 0; i < NUM_JOINTS; i++)
    {
      if((stiffness[i]/100.0)>-3.0&&(stiffness[i]/100.0)<3.0)
      {
     //     if(stiffness[i]!=100.0) cout<<"Stiffness!=100=="<<(stiffness[i]/100.0)<<std::endl;
          processed_joint_commands_->stiffness_[i] = (stiffness[i]/100.0); 
      }
      else 
           processed_joint_commands_->stiffness_[i] =1.0;
     
    }
}


void SpecialMotionModule::processJointHardness(float time) {
    if(time==0.0) return;
    processed_joint_commands_->send_stiffness_ = true;
    processed_joint_commands_->stiffness_time_ = time;
    for (int i = 0; i < NUM_JOINTS; i++)
    {
          processed_joint_commands_->stiffness_[i] = (0.0); 
    }
}

void SpecialMotionModule::executeMotionSequence() {

   doing_specialmotion_ = true;

 // std::cout<< specialmotion_state_time_<<"  "<<std::endl;
   double diff = frame_info_->seconds_since_start - specialmotion_state_time_;

  if (diff < 0.001) {
    specialmotion_pose_count_ = 0;
    processed_joint_commands_->send_stiffness_ = true;
    processed_joint_commands_->stiffness_time_ = 10;
    for (int i = 0; i < NUM_JOINTS; i++)
      processed_joint_commands_->stiffness_[i] = 1.0;
  }
  
  int index = -1;
  int prev = 0;

  for (int i=1; i<MotionSequence.size()+1; i++) {  
    if (diff<times[i]) {
      index = i;
      prev = i-1;
      break;
    }
  }
  if (index<0||index==MotionSequence.size()) {
    specialmotion_state_= 4;
    //motion_->ut_walk_engine_.initStiffness();
       initialized_MotionSequence=false;
       std::cout<<"Finished motion sequence!!!"<<std::endl;
    return;
    
  }

  if (index!=specialmotion_pose_count_) {
    specialmotion_pose_count_= index;
  }   

  const int *signs;
  if (frame_info_->source == MEMORY_ROBOT)
    signs = robot_joint_signs;
  else
    signs = spark_joint_signs;
  

  float interp = (diff-times[prev]) / (times[index]-times[prev]) ;
  interp= interp*(FAST_FACTOR-interp* (FAST_FACTOR-1));
//  std::cout << num_seq_plus << " " << index <<" Diff"<<diff<< std::endl;
  if(biteCMD)
       interp=1.0;
  #ifdef SLOW_DEBUG
   std::cout<<MotionSequence.size()<<"index="<<index<<":"<<interp;
   std::cout<<"=="<<MotionSequence[index].jointMotions[2]<<","<<MotionSequence[index].jointMotions[3]<<","<<MotionSequence[index].jointMotions[4]<<std::endl;
   #else 
   #endif  



  if(MotionSequence[index].mType==Hardness)
  {
       processJointHardness((biteCMD)?1000*(times[index]-times[prev]):1, MotionSequence[index].jointMotions);  
  }
  else if(MotionSequence[index].mType==JointAngle)
 { 
 
     float array[NUM_JOINTS];
     for(int i=0;i< NUM_JOINTS; i++)
     {
      //  int ind = jointMapping[i];  mapping or i, no mapping

        if(MotionSequence[prev].mType!=JointAngle||(fabs(MotionSequence[prev].jointMotions[i]-VOID_NUM) < 1.0)||biteCMDcurr)
        {   // use current angle to interp, if before is jointAngle or VOID or biteCMDcurr
            array[i]= joint_angles_->values_[i]+interp*(MotionSequence[index].jointMotions[i]- joint_angles_->values_[i]);
        } 
         else if(fabs(MotionSequence[index].jointMotions[i]-VOID_NUM) < 1.0)
        {   // use VOID to update, if current is void (if not, the update*interp will results in sth nonVOID)
            array[i]= VOID_NUM;
        }
        else    
        {   //use motion sequence to interp, otherwise
            array[i]= ( MotionSequence[prev].jointMotions[i]+ interp*( MotionSequence[index].jointMotions[i]- MotionSequence[prev].jointMotions[i]));
        }

        array[i]*=DEG_T_RAD;// no sign change: here
   
     }

      processJointArray((biteCMD)?1000*(times[index]-times[prev]):1,array);
   }
}




