#ifndef CROSS_DETECTOR_H
#define CROSS_DETECTOR_H

#include <memory/WorldObjectBlock.h>
#include <memory/FrameInfoBlock.h>
#include <vision/Classifier.h>
#include <vision/BlobDetector.h>
#include <vision/TransformationProvider.h>
#include <vision/Macros.h>
#include <memory/TextLogger.h>
#include <algorithm>

class CrossDetector {
  public:
    CrossDetector(WorldObjectBlock*&, FrameInfoBlock*&, Classifier*&, BlobDetector*&, Vision::TransformationProvider&);
    void detectCross();
    void setHorizon(HorizonLine);
    void init(TextLogger* tl){textlogger = tl;};

  private:
    TextLogger* textlogger;

    WorldObjectBlock*& world_objects_;
    FrameInfoBlock*& vision_frame_info_;

    Classifier*& classifier_;
    BlobDetector*& blob_detector_;
    Vision::TransformationProvider& transform_;
    HorizonLine crossHorizon_;

    float getGreenPercentage(int,int,int,int,int,int);
    void correctRanges(int&,int&,int&,int&,int,int);
    float getDistanceByBlobWidth(float);
    void setCrossObject(Blob*);

};

#endif
