#ifndef CALIBRATIONWINDOW_308GDCNE
#define CALIBRATIONWINDOW_308GDCNE

#include <iostream>
#include "ui_CalibrationWindow.h"
#include <common/RobotInfo.h>
#include <vector>
#include <vision/structures/Sample.h>
#include <vision/CameraCalibration.h>

class CalibrationWindow : public QMainWindow, public Ui_UTCalibWnd {
 Q_OBJECT
  public:
   CalibrationWindow(QMainWindow *parent, QMainWindow *main);
   void addSample(Sample);
   vector<Sample> samples_;
   std::string calibration_file_;
   void saveCalibration(std::string);
   void loadCalibration(std::string);
   void loadCalibration(const CameraCalibration&);
   CameraCalibration getCalibration() const;
  public slots:
   void resetParameters();
   void clear();
   void save();
   void saveAs();
   void load();

};

#endif /* end of include guard: CALIBRATIONWINDOW_308GDCNE */
