#include <QtGui>
#include "ClassificationWindow.h"
#include <iostream>

using namespace std;

ClassificationWindow::ClassificationWindow(QMainWindow* p) {
  setupUi(this);
  setWindowTitle(tr("Classification Window"));
  
  parent = p;
  
  connect (undoButton, SIGNAL(clicked()), parent, SLOT(doUndo()) );
  connect (undefButton, SIGNAL(clicked()), this, SLOT(setUndef()) );
  connect (greenButton, SIGNAL(clicked()), this, SLOT(setGreen()) );
  connect (whiteButton, SIGNAL(clicked()), this, SLOT(setWhite()) );
  connect (orangeButton, SIGNAL(clicked()), this, SLOT(setOrange()) );
  connect (yellowButton, SIGNAL(clicked()), this, SLOT(setGoalYellow()) );
  connect (blueButton, SIGNAL(clicked()), this, SLOT(setGoalBlue()) );
  connect (pinkButton, SIGNAL(clicked()), this, SLOT(setRobotPink()) );
  connect (robotWhiteButton, SIGNAL(clicked()), this, SLOT(setRobotWhite()) );

  // Set string for the segmented colors for drawing
  strCol[c_UNDEFINED]="Undefined";
  strCol[c_FIELD_GREEN]="Field Green";
  strCol[c_WHITE]="White";
//  strCol[c_SHADOW_OBJECT]="Shadow";
//  strCol[c_SHADOW_BLUE]="Shadow Blue";
//  strCol[c_YELLOW_ORANGE]="Yellow Orange";
//  strCol[c_RED_ORANGE]="Red Orange";
  strCol[c_ORANGE]="Orange";
  strCol[c_PINK]="Pink";
//  strCol[c_ROBOT_BLUE]="Robot Blue";
  strCol[c_BLUE]="Blue";
  strCol[c_YELLOW]="Yellow";
  strCol[c_ROBOT_WHITE] = "Robot White";

  for (int i=0; i<NUM_COLORS; i++) {
    colorCombo->addItem(strCol[i]);
  }
  //paintRadio->setChecked(2);
  addRadio->setChecked(2);

  // Todd: disable replace and delete buttons since they do nothing
  replaceRadio->setEnabled(false);
  deleteRadio->setEnabled(false);

}

void ClassificationWindow::setUndef() {
  colorCombo->setCurrentIndex(c_UNDEFINED);
}
void ClassificationWindow::setGreen() {
  colorCombo->setCurrentIndex(c_FIELD_GREEN);
}
void ClassificationWindow::setWhite() {
  colorCombo->setCurrentIndex(c_WHITE);
}
void ClassificationWindow::setOrange() {
  colorCombo->setCurrentIndex(c_ORANGE);
}
void ClassificationWindow::setGoalBlue() {
  colorCombo->setCurrentIndex(c_BLUE);
}
void ClassificationWindow::setGoalYellow() {
  colorCombo->setCurrentIndex(c_YELLOW);
}
void ClassificationWindow::setRobotPink() {
  colorCombo->setCurrentIndex(c_PINK);
}
void ClassificationWindow::setRobotWhite() {
  colorCombo->setCurrentIndex(c_ROBOT_WHITE);
}

